/*
Titre: Exercice5
Description: Programme qui permet d'exprimenter le passage par rfrence pour retourner plusieurs valeurs.
Le programme demande  l'usager de saisir plusieurs valeurs	 travers l'appel d'une fonction. Cette fonction 
fournit  l'appelant la valeur minimale et maximale  travers des refrences. 

Auteur: Anis Boubaker
Date: 2018-02-01
*/

/***********COMMANDES PRPROCESSEUR*************/
#define _CRT_SECURE_NO_WARNINGS
#include <stdlib.h>
#include <stdio.h>
//NDE: Le module limits.h dclare un ensemble de constantes qui dfinissent les tailes minimales
//et maximales de chaque type de donnes primitif (int, char, double, etc.)
//Par exemple, la constahte INT_MAX dfinit la valeur maximale d'un entier, et la INT_MIN la valeur minimale.
#include <limits.h>

/***********CONSTANTES DE COMPILATION*************/
#define NBE_SAISIES 5

/********* DCLARATIONS DES FONCTION **************/
/*
Fonction: min_max_saisie
Description: Denande  l'usager de saisir nbr_saisies valeurs. Elle fournit  l'appelant la plus grande et la 
plus petite des valeurs.
Arguments:
- nbre_saisies (entier): Nombre de valeurs que l'usager doit saisir (>=1); 
- min (pointeur d'entier): Rfrence o sera stocke la valeur minimale saisie
- max (pointeur d'entier): Rfrence o sera stocke la valeur maximale saisie
Paramtres modifis:
- min et max
*/
void min_max_saisie(int nbre_saisies, int *min, int *max);


/*
Fonction: main
Description: 
Arguments:
- Aucuns
*/

int main(void)
{
	//dclaration de variables
	int minimum; //La valeur minimale saisie
	int maximum; //La valeur maximale saisie

	//La saisie se fait  travers la fonction min_max_saisie, le
	//rsultat doivent tre stocks dans minimum et maximum. Pour ce faire
	//on doit transmettre des rfrences vers ces variables. 
	min_max_saisie(NBE_SAISIES, &minimum, &maximum);

	printf("La valeur minimale saisie est: %d\n", minimum);
	printf("La valeur maximale saisie est: %d\n\n", maximum);

	system("pause");
	return EXIT_SUCCESS;
}


/********* IMPLMENTATIONS DES FONCTION **************/
void min_max_saisie(int nbre_saisies, int *min, int *max)
{
	//Dclaration de variables
	int minimum=INT_MAX, //Stocke la valeur minimale saisie 
		maximum=INT_MIN, //Stocke la valeur minimale saisie 
		saisie, //Stocke la dernire saisie de l'usager
		i;		//Compteur de boucle

	for ( i = 0; i < nbre_saisies ; i++)
	{
		printf("Veuillez saisie la valeur %d : ", i + 1);
		scanf("%d", &saisie);

		if (saisie > maximum)
		{
			maximum = saisie;
		}
		if (saisie < minimum)
		{
			minimum = saisie;
		}
	}

	//NDE : On stocke les valeurs de minimum et maximum dans les rfrences fournies par
	//l'appelant. (Pour qu'il soit en mesure d'obtenir les valeurs)
	*min = minimum;
	*max = maximum;

	//Rien  retourner.
}